/*
 * This file is generated by jOOQ.
 */
package com.alkemy.sophia.api.sophiamsinvoice.dbmodel.jooq.tables;


import com.alkemy.sophia.api.sophiamsinvoice.dbmodel.jooq.DefaultSchema;
import com.alkemy.sophia.api.sophiamsinvoice.dbmodel.jooq.Indexes;
import com.alkemy.sophia.api.sophiamsinvoice.dbmodel.jooq.Keys;
import com.alkemy.sophia.api.sophiamsinvoice.dbmodel.jooq.tables.records.MmRipartizioneCaricoRecord;

import java.math.BigDecimal;
import java.sql.Timestamp;
import java.util.Arrays;
import java.util.List;

import javax.annotation.Generated;

import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Identity;
import org.jooq.Index;
import org.jooq.Name;
import org.jooq.Record;
import org.jooq.Schema;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@Generated(
    value = {
        "http://www.jooq.org",
        "jOOQ version:3.11.9"
    },
    comments = "This class is generated by jOOQ"
)
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class MmRipartizioneCarico extends TableImpl<MmRipartizioneCaricoRecord> {

    private static final long serialVersionUID = -2127709690;

    /**
     * The reference instance of <code>MM_RIPARTIZIONE_CARICO</code>
     */
    public static final MmRipartizioneCarico MM_RIPARTIZIONE_CARICO = new MmRipartizioneCarico();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<MmRipartizioneCaricoRecord> getRecordType() {
        return MmRipartizioneCaricoRecord.class;
    }

    /**
     * The column <code>MM_RIPARTIZIONE_CARICO.ID</code>.
     */
    public final TableField<MmRipartizioneCaricoRecord, Long> ID = createField("ID", org.jooq.impl.SQLDataType.BIGINT.nullable(false).identity(true), this, "");

    /**
     * The column <code>MM_RIPARTIZIONE_CARICO.ID_RIPARTIZIONE_SIADA</code>.
     */
    public final TableField<MmRipartizioneCaricoRecord, Long> ID_RIPARTIZIONE_SIADA = createField("ID_RIPARTIZIONE_SIADA", org.jooq.impl.SQLDataType.BIGINT.nullable(false), this, "");

    /**
     * The column <code>MM_RIPARTIZIONE_CARICO.DATA_ORA_CREAZIONE</code>.
     */
    public final TableField<MmRipartizioneCaricoRecord, Timestamp> DATA_ORA_CREAZIONE = createField("DATA_ORA_CREAZIONE", org.jooq.impl.SQLDataType.TIMESTAMP.defaultValue(org.jooq.impl.DSL.field("CURRENT_TIMESTAMP", org.jooq.impl.SQLDataType.TIMESTAMP)), this, "");

    /**
     * The column <code>MM_RIPARTIZIONE_CARICO.VALORE_TOTALE_RIPARTIZIONE</code>.
     */
    public final TableField<MmRipartizioneCaricoRecord, BigDecimal> VALORE_TOTALE_RIPARTIZIONE = createField("VALORE_TOTALE_RIPARTIZIONE", org.jooq.impl.SQLDataType.DECIMAL(60, 10), this, "");

    /**
     * The column <code>MM_RIPARTIZIONE_CARICO.STATO</code>.
     */
    public final TableField<MmRipartizioneCaricoRecord, String> STATO = createField("STATO", org.jooq.impl.SQLDataType.VARCHAR(32).nullable(false), this, "");

    /**
     * The column <code>MM_RIPARTIZIONE_CARICO.VERSIONE</code>.
     */
    public final TableField<MmRipartizioneCaricoRecord, Integer> VERSIONE = createField("VERSIONE", org.jooq.impl.SQLDataType.INTEGER, this, "");

    /**
     * Create a <code>MM_RIPARTIZIONE_CARICO</code> table reference
     */
    public MmRipartizioneCarico() {
        this(DSL.name("MM_RIPARTIZIONE_CARICO"), null);
    }

    /**
     * Create an aliased <code>MM_RIPARTIZIONE_CARICO</code> table reference
     */
    public MmRipartizioneCarico(String alias) {
        this(DSL.name(alias), MM_RIPARTIZIONE_CARICO);
    }

    /**
     * Create an aliased <code>MM_RIPARTIZIONE_CARICO</code> table reference
     */
    public MmRipartizioneCarico(Name alias) {
        this(alias, MM_RIPARTIZIONE_CARICO);
    }

    private MmRipartizioneCarico(Name alias, Table<MmRipartizioneCaricoRecord> aliased) {
        this(alias, aliased, null);
    }

    private MmRipartizioneCarico(Name alias, Table<MmRipartizioneCaricoRecord> aliased, Field<?>[] parameters) {
        super(alias, null, aliased, parameters, DSL.comment(""));
    }

    public <O extends Record> MmRipartizioneCarico(Table<O> child, ForeignKey<O, MmRipartizioneCaricoRecord> key) {
        super(child, key, MM_RIPARTIZIONE_CARICO);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Schema getSchema() {
        return DefaultSchema.DEFAULT_SCHEMA;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public List<Index> getIndexes() {
        return Arrays.<Index>asList(Indexes.MM_RIPARTIZIONE_CARICO_MM_RIPARTIZIONE_CARICHI_ID_UINDEX, Indexes.MM_RIPARTIZIONE_CARICO_PRIMARY);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Identity<MmRipartizioneCaricoRecord, Long> getIdentity() {
        return Keys.IDENTITY_MM_RIPARTIZIONE_CARICO;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public UniqueKey<MmRipartizioneCaricoRecord> getPrimaryKey() {
        return Keys.KEY_MM_RIPARTIZIONE_CARICO_PRIMARY;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public List<UniqueKey<MmRipartizioneCaricoRecord>> getKeys() {
        return Arrays.<UniqueKey<MmRipartizioneCaricoRecord>>asList(Keys.KEY_MM_RIPARTIZIONE_CARICO_PRIMARY, Keys.KEY_MM_RIPARTIZIONE_CARICO_MM_RIPARTIZIONE_CARICHI_ID_UINDEX);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public MmRipartizioneCarico as(String alias) {
        return new MmRipartizioneCarico(DSL.name(alias), this);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public MmRipartizioneCarico as(Name alias) {
        return new MmRipartizioneCarico(alias, this);
    }

    /**
     * Rename this table
     */
    @Override
    public MmRipartizioneCarico rename(String name) {
        return new MmRipartizioneCarico(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public MmRipartizioneCarico rename(Name name) {
        return new MmRipartizioneCarico(name, null);
    }
}
